//
//  GameView.h
//  T4Two
//

#import "common.h"
#import "Celestial/AVController.h"
#import "Celestial/AVQueue.h"
#import "Celestial/AVItem.h"




@interface GameView : UIView
{
	UIImageView *ballView;
	UIImageView *racketView[2];
	UIImageView *barView[2][10];
	UIImage		*barImage[3];
	UITextLabel *label[4];
#ifdef ENABLE_ACCELEROMETER
	UIImageView  *xarrow;
#endif

	int			score[2];
	
	float		ballRadius;
	float		ballAccel;
	CGPoint		ballVector;
	CGPoint		ballPosition;

	CGPoint		racketPosition[2];
	CGPoint		fingerPosition[2];
	CGRect		fingerArea[2];
	BOOL		began[2];
	double		interval;
	BOOL		paused;

	BOOL		sound;
	BOOL		debuginfo;
	
	AVController *av;
	AVQueue		*avQueue;
}

typedef enum
{
	SoundGameServe = 0,
	SoundGameOver,
	SoundHitWall,
	SoundHitRacket0,
	SoundHitRacket1
} SoundIndex;


- (void)acceleratedInX:(float)x Y:(float)y Z:(float)z;
- (void)gameStart;
- (void)gameSuspend;
- (void)gameResume;

- (void)gameLoop:(id)argument;
- (void)ballReset;
- (void)gameScore:(int)player;
- (void)gameRetry;
- (void)loadSound:(NSString *)soundName;
- (void)playSound:(SoundIndex)index;
#ifdef ASPEN
- (void)terminate;
-(void) dispatchTouchEvent:(UIView *)theView toPosition:(CGPoint)p;
#else
- (void)moveRacket:(CGPoint)p;
- (void)mouseDown:(struct __GSEvent *)event;
- (void)mouseDragged:(struct __GSEvent *)event;
- (void)mouseUp:(struct __GSEvent *)event;
#endif



@end
