//
//  T4TwoApp.m
//  T4Two
//

#import "T4TwoApp.h"

@implementation T4TwoApp

//-----------------------------------------------------------------------

- (void) applicationDidFinishLaunching: (id) sender
{
	LogMethod();
	thisApp = self;
	// ステイタス・バーを消す
	[UIHardware _setStatusBarHeight:0.0f];
	[self setStatusBarMode:2 duration:0.0f];
#ifdef ASPEN
	[self setStatusBarHidden:YES animated:NO];	
#endif
	
	// アプリケーションが利用できる領域を求める
	CGRect appRect = [UIHardware fullScreenApplicationContentRect];
	appRect.origin = CGPointZero;

	// ウィンドウを作成
	window = [[UIWindow alloc] initWithContentRect:appRect];
#ifdef ASPEN
	[window makeKeyAndVisible];
#else
	[window makeKey:self];
#endif
	// ウィンドウを表示
	[window orderFront:self];
 	
	// ゲーム・ビューを作成
	gameView = [[[GameView alloc] initWithFrame:appRect] autorelease];
	[window setContentView:gameView];
	// 背景色を設定せずに、ビューを透明にする
	//float bgColor[4] = {0.0f, 0.0f, 0.5f, 0.5f};
	//[gameView setBackgroundColor: CGColorCreate( CGColorSpaceCreateDeviceRGB(), bgColor)];
	
#ifdef ASPEN
#ifdef ENABLE_ACCELEROMETER
	[[UIAccelerometer sharedAccelerometer] setUpdateInterval:(1.0 / kUpdateFrequency)];
	[[UIAccelerometer sharedAccelerometer] setDelegate:self];
#endif
    [gameView setBackgroundColor: [UIColor blackColor]];
	[gameView setMultipleTouchEnabled:YES];
#endif
	// ゲームを開始する
	[gameView gameStart];
}

- (void)applicationWillTerminate
{
	LogMethod();
	[gameView release];
	[window release];
}

//-----------------------------------------------------------------------

// TODO: Suspend&Resume???

- (void)applicationWillSuspend
{
	LogMethod();
	[gameView gameSuspend];
}

- (void)applicationWillSuspendUnderLock
{
	LogMethod();
	[gameView gameSuspend];
}

- (void)applicationDidResume
{
	LogMethod();
	[gameView gameResume];
}
- (void)applicationDidResumeFromUnderLock
{
	LogMethod();
	[gameView gameResume];
}

//-----------------------------------------------------------------------
#ifdef ASPEN
// UIAccelerometer delegate method in SDK
- (void)accelerometer:(UIAccelerometer *)accelerometer didAccelerate:(UIAcceleration *)acceleration {

	[gameView acceleratedInX:acceleration.x Y:acceleration.y Z:acceleration.z];
}
#else

- (void)acceleratedInX:(float)x Y:(float)y Z:(float)z
{
	[gameView acceleratedInX:x Y:y Z:z];
}
#endif
//-----------------------------------------------------------------------

@end

